/*
 *                      Micro `who' :-)
 *
 *	Copyright (c) 2002 by Andy Pershin <apa@puug.org.ru>
 *
 *	This program is free software; you can redistribute it
 *	and/or  modify it under  the terms of  the GNU General
 *	Public  License as  published  by  the  Free  Software
 *	Foundation;  either  version 2 of the License, or  (at
 *	your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 * $Id: who.c,v 1.2 2002/09/09 18:19:06 apa Exp $
 */

#include <stdio.h>
#include <utmp.h>
#include <time.h>
#include <string.h>

#include "gwbox.h"

int who_main (int argc, char *argv[]) {

    struct utmp *u;
    time_t t;
    char date[15];

    setutent();
    while ((u = getutent())) {
        if (u->ut_type == USER_PROCESS) {
            t = u->ut_tv.tv_sec;
            strftime(date, sizeof(date)-1, "%b %e %H:%M", localtime(&t));
            printf("%s\t%s\t%s\t(%s)\n",
                    u->ut_user, u->ut_line, date, u->ut_host);
        }
    }
    endutent();
    return 0;
}
